/* -*- buffer-read-only: t -*- vi: set ro:
#line 431
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 431
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_IPADDR
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_ipaddr.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 17
   Copyright (C) 2007 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

void
#line 23
bi_ntohl(eval_environ_t env)
#line 23

#line 23 "bi_ipaddr.m4"
{
#line 23
	
#line 23
long  n = (long ) get_numeric_arg(env, 0);
#line 23
        
#line 23
        adjust_stack(env, 1);
#line 23

#line 23
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 23
		prog_trace(env, "ntohl %lu",n);;
#line 23

{
	do {
#line 25
push(env, (STKVAL) (ntohl((uint32_t) n)));
#line 25
return;
#line 25
} while (0);
}
}

void
#line 29
bi_htonl(eval_environ_t env)
#line 29

#line 29 "bi_ipaddr.m4"
{
#line 29
	
#line 29
long  n = (long ) get_numeric_arg(env, 0);
#line 29
        
#line 29
        adjust_stack(env, 1);
#line 29

#line 29
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 29
		prog_trace(env, "htonl %lu",n);;
#line 29

{
	do {
#line 31
push(env, (STKVAL) (htonl((uint32_t) n)));
#line 31
return;
#line 31
} while (0);
}
}

#line 37
/* FIXME: The following functions assume binary complement arithmetics.
#line 37
   This is hardly a limitation, the similar approach works in GNU Radius
#line 37
   for years. Nevertheless, this assumption should be noted. */

void
#line 39
bi_ntohs(eval_environ_t env)
#line 39

#line 39 "bi_ipaddr.m4"
{
#line 39
	
#line 39
long  n = (long ) get_numeric_arg(env, 0);
#line 39
        
#line 39
        adjust_stack(env, 1);
#line 39

#line 39
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 39
		prog_trace(env, "ntohs %lu",n);;
#line 39

{
	do {
#line 41
push(env, (STKVAL) ((uint32_t) ntohs(((uint16_t) n) & 0xffff)));
#line 41
return;
#line 41
} while (0);
}
}

void
#line 45
bi_htons(eval_environ_t env)
#line 45

#line 45 "bi_ipaddr.m4"
{
#line 45
	
#line 45
long  n = (long ) get_numeric_arg(env, 0);
#line 45
        
#line 45
        adjust_stack(env, 1);
#line 45

#line 45
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 45
		prog_trace(env, "htons %lu",n);;
#line 45

{
	do {
#line 47
push(env, (STKVAL) ((uint32_t) htons(((uint16_t) n) & 0xffff)));
#line 47
return;
#line 47
} while (0);
}
}

void
#line 51
bi_inet_aton(eval_environ_t env)
#line 51

#line 51 "bi_ipaddr.m4"
{
#line 51
	
#line 51
char * s = (char *) get_string_arg(env, 0);
#line 51
        
#line 51
        adjust_stack(env, 1);
#line 51

#line 51
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 51
		prog_trace(env, "inet_aton %s",s);;
#line 51

{
	struct in_addr addr;

		if (!(inet_aton(s, &addr)))
#line 58
			env_throw_bi(env, mf_invip,                                             "inet_aton: ", _("Invalid IP address (%s)"),s);
#line 58
;
#line 58
;
	do {
#line 59
push(env, (STKVAL) (ntohl(addr.s_addr)));
#line 59
return;
#line 59
} while (0);
}
}

void
#line 63
bi_inet_ntoa(eval_environ_t env)
#line 63

#line 63 "bi_ipaddr.m4"
{
#line 63
	
#line 63
long  ip = (long ) get_numeric_arg(env, 0);
#line 63
        
#line 63
        adjust_stack(env, 1);
#line 63

#line 63
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 63
		prog_trace(env, "inet_ntoa %lu",ip);;
#line 63

{
	struct in_addr addr;

	addr.s_addr = htonl(ip);
	do {pushs(env, inet_ntoa(addr));
#line 68
return;
#line 68
} while (0);
}
}

void
#line 72
bi_len_to_netmask(eval_environ_t env)
#line 72

#line 72 "bi_ipaddr.m4"
{
#line 72
	
#line 72
long  x = (long ) get_numeric_arg(env, 0);
#line 72
        
#line 72
        adjust_stack(env, 1);
#line 72

#line 72
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 72
		prog_trace(env, "len_to_netmask %lu",x);;
#line 72

{
	unsigned long n = (unsigned long) x;
	unsigned long netmask;

		if (!(n <= 32))
			env_throw_bi(env, mf_range,                                             "len_to_netmask: ", _("Invalid netmask: %lu"),n);
#line 78
;
#line 78
;
	n = 32 - n;
	if (n == 32)
		netmask = 0;
	else
		netmask = (0xfffffffful >> n) << n;
	do {
#line 84
push(env, (STKVAL) (netmask));
#line 84
return;
#line 84
} while (0);
}
}

void
#line 88
bi_netmask_to_len(eval_environ_t env)
#line 88

#line 88 "bi_ipaddr.m4"
{
#line 88
	
#line 88
long  x = (long ) get_numeric_arg(env, 0);
#line 88
        
#line 88
        adjust_stack(env, 1);
#line 88

#line 88
	if (prog_trace_option & BUILTIN_MASK_ipaddr)
#line 88
		prog_trace(env, "netmask_to_len %lu",x);;
#line 88

{
	unsigned long n = (unsigned long) x;
	unsigned long i;

	for (i = 32; i > 0; i--) {
		if (n & 1)
			break;
		n >>= 1;
	}
	do {
#line 98
push(env, (STKVAL) (i));
#line 98
return;
#line 98
} while (0);
}
}


#line 102
void
#line 102
ipaddr_init_builtin()
#line 102
{
#line 102
	#line 23 "bi_ipaddr.m4"
va_builtin_install_ex("ntohl", bi_ntohl, 0, 0, dtype_number,  1, 0,  dtype_number);
#line 29 "bi_ipaddr.m4"
va_builtin_install_ex("htonl", bi_htonl, 0, 0, dtype_number,  1, 0,  dtype_number);
#line 39 "bi_ipaddr.m4"
va_builtin_install_ex("ntohs", bi_ntohs, 0, 0, dtype_number,  1, 0,  dtype_number);
#line 45 "bi_ipaddr.m4"
va_builtin_install_ex("htons", bi_htons, 0, 0, dtype_number,  1, 0,  dtype_number);
#line 51 "bi_ipaddr.m4"
va_builtin_install_ex("inet_aton", bi_inet_aton, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 63 "bi_ipaddr.m4"
va_builtin_install_ex("inet_ntoa", bi_inet_ntoa, 0, 0, dtype_string,  1, 0,  dtype_number);
#line 72 "bi_ipaddr.m4"
va_builtin_install_ex("len_to_netmask", bi_len_to_netmask, 0, 0, dtype_number,  1, 0,  dtype_number);
#line 88 "bi_ipaddr.m4"
va_builtin_install_ex("netmask_to_len", bi_netmask_to_len, 0, 0, dtype_number,  1, 0,  dtype_number);

#line 102 "bi_ipaddr.m4"
		
#line 102
}


#line 0

#line 0

